=== debian/changelog ===
bareos (24.0.0~pre495.c22a2f809-3) unstable; urgency=low

  * See https://docs.bareos.org/release-notes/

 -- Bareos Jenkins <noreply@bareos.com>  Thu, 11 Apr 2024 08:55:14 +0000
